> module GenParse (Parser,ap,sat,lit,eof,residue,rep,rep1,opt) where

The type `Token' just has to have an equals method. 

 > type Token = String 

 > newtype ParserX a t = PX ([t] -> Maybe(a,[t]))

> newtype Parser token a  = P ([token] -> Maybe (a,[token]))

> ap :: Parser token a -> [token] -> Maybe(a,[token])
> ap (P f) s = f s

> instance Monad (Parser token) where
>   x >>= k  = P (\s -> case ap x s of 
>                          Nothing -> Nothing 
>                          Just (x,s') -> ap (k x) s' )
>   return x = P (\s -> Just (x,s))

> instance MonadZero (Parser token) where
>   zero = P (\s -> Nothing )

> instance MonadPlus (Parser token) where
>   (P f) ++ (P g) 
>         = P (\s -> let x = f s in case x of { Nothing -> g s ; _ -> x })

> sat :: (token -> Bool) -> Parser token token 
> sat p = P (\ts-> 
>            case ts of 
>              (t:ts) -> if p t then Just (t,ts) else Nothing
>              _      -> Nothing)

> eof :: Parser token ()
> eof   = P (\ss-> case ss of [] -> Just((),ss) ; _ -> Nothing)

> residue :: Parser token [token]
> residue = P (\s-> Just (s,[]))

> rep, rep1 :: Parser t a -> Parser t [a]
> opt       :: Parser t [a] -> Parser t [a]

> rep p  = opt (rep1 p) 
> rep1 p = do x  <- p 
>             xs <- rep p 
>             return (x:xs) 
> opt p  = p ++ return []

> lit    :: Eq token => token -> Parser token token
> lit    = sat . (==) 
